﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Cv4_forms2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            // prace s properties
            exitToolStripMenuItem.Text = Properties.Resources.exitString;

            // zmena locale
            Thread.CurrentThread.CurrentUICulture = CultureInfo.GetCultureInfo("cs-CZ");
            
            richTextBox1.AppendText(Properties.strings.str1 + "\n");
            richTextBox1.AppendText(Properties.strings.str2 + "\n");
            richTextBox1.AppendText(Properties.strings.str3 + "\n");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ChangeColor();
        }

        private void ChangeColor()
        {
            colorDialog1.ShowDialog();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ChangeFont();
        }

        private void ChangeFont()
        {
            fontDialog1.ShowDialog();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void changeFontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeFont();
        }

        private void changeColorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeColor();
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string items = "";
            foreach (object item in listBox1.SelectedItems)
            {
                 items += "{" + item.ToString() +"}";
            }
            label1.Text = items;
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            // inicializace scrollbaru
            
            hScrollBar1.Minimum = 0;
            vScrollBar1.Minimum = 0;

            hScrollBar1.Maximum = pictureBox1.Image.Width - pictureBox1.ClientSize.Width;
            vScrollBar1.Maximum = pictureBox1.Image.Height - pictureBox1.ClientSize.Height;

            hScrollBar1.SmallChange = hScrollBar1.Maximum / 20;
            vScrollBar1.SmallChange = vScrollBar1.Maximum / 20;

            hScrollBar1.LargeChange = hScrollBar1.Maximum / 10;
            vScrollBar1.LargeChange = hScrollBar1.Maximum / 10;

            // je treba pridat "velkou zmenu" - v podstate sirku scrollbaru
            hScrollBar1.Maximum += hScrollBar1.LargeChange - 1;
            vScrollBar1.Maximum += vScrollBar1.LargeChange - 1;

            //MessageBox.Show(String.Format("{0},{1},{2},{3}", pictureBox1.Image.Width, pictureBox1.ClientSize.Width, pictureBox1.Width, hScrollBar1.Maximum));
        }

        private void ProcessScroll(object sender, ScrollEventArgs e)
        {
            // reakce na posun scrollbaru
            using (Graphics g = pictureBox1.CreateGraphics())
            {
                g.DrawImage(pictureBox1.Image, 0 - hScrollBar1.Value, 0 - vScrollBar1.Value);
            }
        }

        private void textBox1_Validating(object sender, CancelEventArgs e)
        {
            TextBox t = (TextBox)sender;
            int val;

            if (!int.TryParse(t.Text, out val)
                && !string.IsNullOrWhiteSpace(t.Text))
            {
                t.ForeColor = Color.Red;
                e.Cancel = true;
            }
            else
            {
                t.ForeColor = Color.Black;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label1.Text += "a";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
            {
                timer1.Stop();
                ((Button)sender).Text = "Start timer";

            }
            else
            {
                timer1.Start();
                ((Button)sender).Text = "Stop timer";
            }
        }
    }
}
